'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _document = require('./document');

var _document2 = _interopRequireDefault(_document);

var _mark = require('./mark');

var _mark2 = _interopRequireDefault(_mark);

var _selection = require('./selection');

var _selection2 = _interopRequireDefault(_selection);

var _transform = require('./transform');

var _transform2 = _interopRequireDefault(_transform);

var _uid = require('../utils/uid');

var _uid2 = _interopRequireDefault(_uid);

var _immutable = require('immutable');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * History.
 *
 * @type {History}
 */

var History = function () {
  _createClass(History, null, [{
    key: 'create',


    /**
     * Create a new `History` with `properties`.
     *
     * @param {Object} properties
     * @return {History} state
     */

    value: function create(properties) {
      if (properties instanceof History) return properties;
      return new History(properties);
    }

    /**
     * Constructor.
     *
     * @param {Object} properties
     */

  }]);

  function History(properties) {
    _classCallCheck(this, History);

    this.undos = properties.undos || new _immutable.Stack();
    this.redos = properties.redos || new _immutable.Stack();
  }

  /**
   * Get the kind.
   *
   * @return {String} kind
   */

  _createClass(History, [{
    key: 'kind',
    get: function get() {
      return 'history';
    }

    /**
     * Are there undoable events?
     *
     * @return {Boolean} hasUndos
     */

  }, {
    key: 'hasUndos',
    get: function get() {
      return this.undos.size > 0;
    }

    /**
     * Are there redoable events?
     *
     * @return {Boolean} hasRedos
     */

  }, {
    key: 'hasRedos',
    get: function get() {
      return this.redos.size > 0;
    }
  }]);

  return History;
}();

/**
 * Export.
 *
 * @type {History}
 */

exports.default = History;